//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//>> URL Declarations
var URL = new Object;
URL.BaG_WebSite = "http://www.buildagadget.com/";
URL.BaG_Product = "http://www.buildagadget.com/x/product/DT";
URL.BaG_Support = "http://www.buildagadget.com/x/support/DT";
URL.BaG_Contact = "http://www.buildagadget.com/x/contact/DT";
URL.BaG_DonateL = "http://www.buildagadget.com/x/donate/DT";
URL.BaG_Updater = "http://www.buildagadget.com/x/update/DT";
URL.BaG_Twitter = "http://www.buildagadget.com/x/twitter";
URL.BaG_AlarmFB = "http://www.buildagadget.com/Gadgets/Core/DT/Alarm-Bottom.php";
URL.BaG_CalEvFB = "http://www.buildagadget.com/Gadgets/Core/DT/Calendar-Bottom.php";
URL.BaG_CalEvPD = "http://www.buildagadget.com/Gadgets/Core/DT/Preset-Dates.xml";

//>> Timers
var Timer_Clocks;
var Timer_Checker;
var Timer_Snooze;

//>> Settings File
System.Gadget.settingsUI = "Settings.html";

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Init
//  PARAMS >> None
//*************************************************************
function GADGET_Init()
{
	//>> Load Data From File
	UTIL_STOR_Load();
	
	//>> Load Alarms
	GADGET_ALARMS_Load();
	
	//>> Check If We Need To Upgrade
	if (UTIL_VAR_Read("Events_Upgraded", '') == '')
		GADGET_EVENTS_Upgrade();
	else
		GADGET_EVENTS_Load();
	
	//>> Load Theme
	var Theme_Type = UTIL_VAR_Read("Theme_Type", "Standard");
	var Theme_Custom = UTIL_VAR_Read("Theme_Custom", '');
	var Theme_Preset = UTIL_VAR_Read("Theme_Preset", "1");
		
	if (Theme_Type == "Custom" && Theme_Custom != '')
		$B_BG("url('" + Theme_Custom + "') repeat-y");
	else
		$B_BG("url('Images/Themes/BG-Theme-" + Theme_Preset + ".jpg') repeat-y");
		
	//> Get Font Styles
	var Font_Size = UTIL_VAR_Read("Font_Size", "12");
	var Font_Color = UTIL_VAR_Read("Font_Color", "white");
	
	//>> Construct Basic UI
	var Str = "<div id='Sec-Clocks' style='font-size: " + Font_Size + "px; color: " + Font_Color + "'></div>";
	Str += "<div id='Sec-Buttons'>";
		Str += "<div id='Button-Calendar' title='Calendar' onclick='GADGET_FLYOUT_Calendar();'></div>";
		Str += "<div id='Button-Event' title='Today&prime;s Events!' style='display:none;' onclick='GADGET_FLYOUT_Events();'></div>";
		Str += "<div id='Button-Alarm' title='Alarm' class='Button-Alarm-Orig' onclick='GADGET_FLYOUT_Alarm();'></div>";
	Str += "</div>";
	
	$_HTML("Gadget-Content", Str);
	
	//>> Make Sure Alarm Is Off
	$("Alarm").src = '';
	clearInterval(Timer_Snooze);
	
	//>> Construct Clocks
	GADGET_Clocks_Disp();
	GADGET_Update_Clocks();
	GADGET_EVENTS_Check();
	
	//>> Clear / Set Timers
	clearInterval(Timer_Clocks);
	Timer_Clocks = setInterval(GADGET_Update_Clocks, 1000);
	
	clearInterval(Timer_Checker);
	Timer_Alarm = setInterval(GADGET_Check_Time_Date, 1000);
	
	$("JumpStart").click();
}

//*************************************************************
//  GADGET >> Jumpstart Clock Timers
//  PARAMS >> None
//*************************************************************
function GADGET_Timers_Jumpstart()
{	
	try
	{
		GADGET_Update_Clocks();
		GADGET_ALARM_Check();
		GADGET_EVENTS_Check();
	
		clearInterval(Timer_Clocks);
		Timer_Clocks = setInterval(GADGET_Update_Clocks, 1000);

		clearInterval(Timer_Checker);
		Timer_Alarm = setInterval(GADGET_Check_Time_Date, 1000);
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> Read File & Construct Clocks
//  PARAMS >> None
//*************************************************************
function GADGET_Clocks_Disp()
{	
	try
	{
		//>> Load Control XML File
		UTIL_XML_Load(STOR_File);
		var xFile = XML_Doc.getElementsByTagName("Storage")[0];

		//>> Parse Location
		var xFile_Location = xFile.getElementsByTagName("Location")[0];
		var Path = xFile_Location.getElementsByTagName("Path")[0].text;
		var File = xFile_Location.getElementsByTagName("Clocks")[0].text;

		//>> Verify Path
		var sPath = UTIL_STOR_Check_Path(Path);		
		var sFile = sPath + "\\" + File;

		//>> Test For File
		if (FSO.FileExists(sFile))
		{
			UTIL_XML_Load(sFile);
			var xFile = XML_Doc.getElementsByTagName("Clocks")[0];
			var Str = '';
			var i = 0;

			try
			{
				Str += "<div id='Sec-Alarm' class='DT-Clock' style='display:none;'>";
					Str += "<img src='Images/Buttons/Img-Alarm.png' style='float: left; margin-left: 2px; cursor: auto;' title='Alarm!' />";
					Str += "<div id='Button-Alarm-Off' onclick='GADGET_ALARMS_Stop();' title='Stop Alarm'></div>";
					Str += "<div id='Button-Alarm-Snooze' onclick='GADGET_ALARMS_Snooze();' title='Snooze'></div>";
				Str += "</div>";
				
				var Num_Analog = 0;
				var xFile_Items = xFile.getElementsByTagName("Clock");
				if (xFile_Items.length > 0)
				{
					while (i < xFile_Items.length)
					{	
						if (xFile_Items[i].getAttribute("Format") != "Analog")
							Str += "<div id='DT-Clock-" + i + "' class='DT-Clock'></div>";
						else
						{
							Str += "<div id='DT-Clock-" + i + "' class='DT-Clock-Analog'>";
							Str += "</div>";
						}
						Str += "<div id='DT-Clock-" + i + "-Timezone' class='Hidden'>" + xFile_Items[i].getAttribute("Timezone") + "</div>";
						Str += "<div id='DT-Clock-" + i + "-Format' class='Hidden'>" + xFile_Items[i].getAttribute("Format") + "</div>";
						Str += "<div id='DT-Clock-" + i + "-Label' class='Hidden'>" + xFile_Items[i].getAttribute("Label") + "</div>";
						
						if (xFile_Items.length > 1 && (i+1) != xFile_Items.length)
							Str += "<div class='DT-Spacer'></div>";
							
						if (xFile_Items[i].getAttribute("Format") == "Analog")
							Num_Analog++;
						i++;
					}
					$_HTML("Sec-Clocks", Str);
					UTIL_VAR_Write("Num_Clocks", i);
				}
				else
					UTIL_VAR_Write("Num_Clocks", 0);
			}
			catch(err){}

			//>> Determine New Gadget Size
			if (UTIL_VAR_Read("Num_Clocks", 0) == 0)
				UTIL_VAR_Write("Num_Clocks", 1);
			var Num_Clocks = UTIL_VAR_Read("Num_Clocks", 0)
			System.Gadget.document.body.style.height = (25 + ((Num_Clocks - Num_Analog) * 35) + (Num_Analog * 145) + ((Num_Clocks - 1) * 4)) + "px";
			$("Sec-Clocks").style.height = (((Num_Clocks - Num_Analog) * 35) + (Num_Analog * 145) + ((Num_Clocks - 1) * 4)) + "px";
			GADGET_Border();
		}
		else
		{
			try
			{
				//>> Set Presets
				var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?>';
				Str += '<Clocks><Clock Timezone="Local" Format="DateTime" Label="" /></Clocks>';

				if (FSO.FileExists(sFile))
					FSO.DeleteFile(sFile, true);

				var oFile = FSO.CreateTextFile(sFile, true);
				oFile.WriteLine(Str);
				oFile.Close();
				GADGET_Clocks_Disp();
			}
			catch(err){}
		}
		$("JumpStart").click();
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> Create Border
//  PARAMS >> None
//*************************************************************
function GADGET_Border()
{
	var Str = "<img src='Images/BG/BG-Border-TB.png' style='position: absolute; top: 0; left: 0;' />";
	Str += "<img src='Images/BG/BG-Border-TB.png' style='position: absolute; bottom: 0; left: 0;' />";
	Str += "<img src='Images/BG/BG-Border-LR.png' style='position: absolute; top: 0; left: 0;' />";
	Str += "<img src='Images/BG/BG-Border-LR.png' style='position: absolute; top: 0; right: 0;' />";
	if (UTIL_VAR_Read("Corners", "Rounded") == "Rounded")
	{
		Str += "<img src='Images/BG/Corner-TL.png' style='position: absolute; top: 0; left: 0;' />";
		Str += "<img src='Images/BG/Corner-TR.png' style='position: absolute; top: 0; right: 0;' />";
		Str += "<img src='Images/BG/Corner-BL.png' style='position: absolute; bottom: 0; left: 0;' />";
		Str += "<img src='Images/BG/Corner-BR.png' style='position: absolute; bottom: 0; right: 0;' />";
	}
	$_HTML("Gadget-Border", Str);
}

//*************************************************************
//  GADGET >> Start Clocks Update
//  PARAMS >> None
//*************************************************************
function GADGET_Update_Clocks()
{
	try
	{
		var Str = '';
		var i = 0;
		var Num_Clocks = UTIL_VAR_Read("Num_Clocks", 0);
		while (i < Num_Clocks)
		{
			var Timezone = $("DT-Clock-" + i + "-Timezone").innerText;
			var Format = $("DT-Clock-" + i + "-Format").innerText;
			var Label = $("DT-Clock-" + i + "-Label").innerText;
			var xDate = GADGET_Get_Date(Timezone);
			var xTime = GADGET_Get_Time(Timezone);		
 
			if (Format == "DateTime")
				Str = "<div class='DT-DateTime'><span onclick='GADGET_FLYOUT_Calendar();'>" + xDate + "<br />" + xTime + "</span></div>";
			else if (Format == "Date")
				Str = "<div class='DT-Single'><span onclick='GADGET_FLYOUT_Calendar();'>" + xDate + "</span></div>";
			else if (Format == "DateLabel")
				Str = "<div class='DT-Label' title='" + Label + "'><span onclick='GADGET_FLYOUT_Calendar();'>" + Label + "</div><div class='DT-DateTime'>" + xDate + "</span></div>";
			else if (Format == "Time")
				Str = "<div class='DT-Single'><span onclick='GADGET_FLYOUT_Calendar();'>" + xTime + "</span></div>";
			else if (Format == "TimeLabel")
				Str = "<div class='DT-Label' title='" + Label + "'><span onclick='GADGET_FLYOUT_Calendar();'>" + Label + "</div><div class='DT-DateTime'>" + xTime + "</span></div>";
			else if (Format == "Analog")
			{
				try
				{
					if (Timezone != "Local")
					{	
						var TMZ_Zones = System.Time.timeZones;
						var TMZ_Zone = TMZ_Zones.item(parseInt(Timezone));		
						var TMZ_Local = System.Time.getLocalTime(TMZ_Zone);
						var xDate = new Date(TMZ_Local);
					}
					else
						var xDate = new Date();
   
					var Minutes = xDate.getMinutes();
					var Seconds = xDate.getSeconds();
					var Hours = xDate.getHours();
					
					if (parseInt(Hours) > 12)
						Hours = parseInt(Hours) - 12;
						
					var xTime = GADGET_Get_Time(Timezone);
					var Analog_Seconds = UTIL_VAR_Read("Analog_Seconds", "On");
						
					Str = "<div class='DT-Analog-BG' title='" + xTime + "' onclick='GADGET_FLYOUT_Calendar();'>";
						Str += "<div class='DT-Analog-Dot'>";
							if (Analog_Seconds == "On")
								Str += "<div class='DT-Analog-Seconds' style='background: url(\"Images/Analog/Seconds/Analog-Seconds-" + Seconds + ".png\") center center no-repeat;'>";
									Str += "<div class='DT-Analog-Minutes' style='background: url(\"Images/Analog/Minutes/Analog-Minutes-" + Minutes + ".png\") center center no-repeat;'>";
										Str += "<div class='DT-Analog-Hours' style='background: url(\"Images/Analog/Hours/Analog-Hours-" + Hours + ".png\") center center no-repeat;'>";
											Str += "<div class='DT-Analog-Highlight'></div>";
										Str += "</div>";
									Str += "</div>";
							if (Analog_Seconds == "On")
								Str += "</div>";
						Str += "</div>";
					Str += "</div>";
					Str += "<div class='DT-Label' title='" + Label + "'><span onclick='GADGET_FLYOUT_Calendar();'>" + Label + "</span></div>";
					
				}
				catch(err){}			
			}
   
			$_HTML("DT-Clock-" + i, Str);
			i++;
		}
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> Get Date
//  PARAMS >> Zone (Timezone Offset)
//*************************************************************
function GADGET_Get_Date(Zone)
{
	var Date_Format = UTIL_VAR_Read("Date_Format", "%N% %D%, %Y%");		
	if (Zone != "Local")
	{
  		var TMZ_Zones = System.Time.timeZones;
		var TMZ_Zone = TMZ_Zones.item(parseInt(Zone));		
		var TMZ_Local = System.Time.getLocalTime(TMZ_Zone);
		var xDate = new Date(TMZ_Local);
	}
	else
		var xDate = new Date();
		
	var Day = xDate.getDate();
	var Month = xDate.getMonth() + 1;
	var Year = xDate.getYear();
	var WDay = xDate.getDay();

	var DateArray = new Array();
	var DateStr = xDate.toString();
	DateArray = DateStr.split(" ");

	var TMonth=new Array(12);
		TMonth[0]="January";
		TMonth[1]="February";
		TMonth[2]="March";
		TMonth[3]="April";
		TMonth[4]="May";
		TMonth[5]="June";
		TMonth[6]="July";
		TMonth[7]="August";
		TMonth[8]="September";
		TMonth[9]="October";
		TMonth[10]="November";
		TMonth[11]="December";

	var TWeekDay=new Array(7);
		TWeekDay[0]="Sunday";
		TWeekDay[1]="Monday";
		TWeekDay[2]="Tuesday";
		TWeekDay[3]="Wednesday";
		TWeekDay[4]="Thursday";
		TWeekDay[5]="Friday";
		TWeekDay[6]="Saturday";

	//>> Construct Date
	Date_Format = Date_Format.replace(/%N%/, DateArray[1]);
	Date_Format = Date_Format.replace(/%D%/, Day);
	Date_Format = Date_Format.replace(/%Y%/, Year);
	Date_Format = Date_Format.replace(/%M%/, TMonth[Month-1]);
	Date_Format = Date_Format.replace(/%d%/, DateArray[0]);
	Date_Format = Date_Format.replace(/%m%/, Month);
	Date_Format = Date_Format.replace(/%W%/, TWeekDay[WDay]);
	
	return Date_Format;
}

//*************************************************************
//  GADGET >> Get Time
//  PARAMS >> Zone (Timezone Offset)
//*************************************************************
function GADGET_Get_Time(Zone)
{
	var Time_Format = UTIL_VAR_Read("Time_Format", "%H%:%M%:%S% %AMPM%");
	if (Zone != "Local")
	{	
		var TMZ_Zones = System.Time.timeZones;
		var TMZ_Zone = TMZ_Zones.item(parseInt(Zone));		
		var TMZ_Local = System.Time.getLocalTime(TMZ_Zone);
		var xDate = new Date(TMZ_Local);
	}
	else
		var xDate = new Date();

	var Minutes = xDate.getMinutes();
	var Seconds = xDate.getSeconds();
	
	Minutes = Minutes + "";
	if (Minutes.length == 1)
		Minutes = "0" + Minutes;

	Seconds = Seconds + "";
	if (Seconds.length == 1)
		Seconds = "0" + Seconds;

	var Hours = xDate.getHours();
	var MilHours = Hours;
	var amPM = "AM";
	if (Hours > 11) 
		amPM = "PM";
	if (Hours > 12)
		Hours = Hours - 12;
	if (Hours == 0) 
		Hours = 12;
		
	var DateArray = new Array();
	var DateStr = xDate.toString();
	DateArray = DateStr.split(" ");
		
	//>> Construct Time
	Time_Format = Time_Format.replace(/%H%/, Hours);
	Time_Format = Time_Format.replace(/%M%/, Minutes);
	Time_Format = Time_Format.replace(/%S%/, Seconds);
	Time_Format = Time_Format.replace(/%AMPM%/, amPM);
	Time_Format = Time_Format.replace(/%d%/, DateArray[0]);
	Time_Format = Time_Format.replace(/%Mil%/, MilHours);
	
	return Time_Format;
}

//*************************************************************
//  GADGET >> Check Time & Date
//  PARAMS >> None
//*************************************************************
function GADGET_Check_Time_Date()
{
	var xDate = new Date();

	var Minutes = xDate.getMinutes();
	var Seconds = xDate.getSeconds();

	if (Seconds == 0)
	{
		GADGET_ALARMS_Check();
		GADGET_EVENTS_Check();
	}
}

//*************************************************************
//  GADGET >> Generate ID
//  PARAMS >> None
//*************************************************************
function GADGET_Generate_ID()
{
	var i = 0;
	var Chars = new Array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','0','1','2','3','4','5','6','7','8','9');
	var Code = '';
	var Flag = '';
	while (i < 5)
	{
		Code += Chars[Math.ceil(Math.random() * 35)];
		i++;
	}
	
	//>> Check Code
	try
	{
		i = 0;
		var Alarms_Count = parseInt($("Alarms-Count").innerHTML);
		while (i < Alarms_Count)
		{
			if (Code == $("DT-Alarm-" + i + "-ID").innerHTML)
				Flag = "Duplicate";
			i++;
		}
	}
	catch(err){}
	
	try
	{
		i = 0;
		var Events_Count = parseInt($("Events-Count").innerHTML);
		while (i < Events_Count)
		{
			if (Code == $("DT-Event-" + i + "-ID").innerHTML)
				Flag = "Duplicate";
			i++;
		}
	}
	catch(err){}
	
	if (Flag == "Duplicate")
		GADGET_Generate_ID();
	else
		return Code;
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> FLYOUT: Check Specified Flyouts & Close
//  PARAMS >> None
//*************************************************************
function GADGET_FLYOUT_Check()
{
	if (System.Gadget.Flyout.show == true)
		System.Gadget.Flyout.show = false;
}

//*************************************************************
//  GADGET >> FLYOUT: Alarm Flyout
//  PARAMS >> None
//*************************************************************
function GADGET_FLYOUT_Alarm()
{
	if (System.Gadget.Flyout.show == false)
	{
		System.Gadget.Flyout.file = "Flyouts/Flyout-Alarm.html";
		UTIL_VAR_Write("Flyout_File", "Flyouts/Flyout-Alarm.html");
		System.Gadget.Flyout.show = true;
	}
	else
		System.Gadget.Flyout.show = false;
}

//*************************************************************
//  GADGET >> FLYOUT: Calendar Flyout
//  PARAMS >> None
//*************************************************************
function GADGET_FLYOUT_Calendar()
{
	if (System.Gadget.Flyout.show == false)
	{
		System.Gadget.Flyout.file = "Flyouts/Flyout-Calendar.html";
		UTIL_VAR_Write("Flyout_File", "Flyouts/Flyout-Calendar.html");
		System.Gadget.Flyout.show = true;
	}
	else
		System.Gadget.Flyout.show = false;
}

//*************************************************************
//  GADGET >> FLYOUT: Events Flyout
//  PARAMS >> None
//*************************************************************
function GADGET_FLYOUT_Events()
{
	if (System.Gadget.Flyout.show == false)
	{
		System.Gadget.Flyout.file = "Flyouts/Flyout-Events.html";
		UTIL_VAR_Write("Flyout_File", "Flyouts/Flyout-Events.html");
		System.Gadget.Flyout.show = true;
	}
	else
		System.Gadget.Flyout.show = false;
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> ALARMS: Load
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Load()
{
	try
	{
		//>> Load Control XML File
		UTIL_XML_Load(STOR_File);
		var xFile = XML_Doc.getElementsByTagName("Storage")[0];

		//>> Parse Location
		var xFile_Location = xFile.getElementsByTagName("Location")[0];
		var Path = xFile_Location.getElementsByTagName("Path")[0].text;
		var File = xFile_Location.getElementsByTagName("Alarms")[0].text;

		//>> Verify Path
		var sPath = UTIL_STOR_Check_Path(Path);		
		var sFile = sPath + "\\" + File;

		//>> Test For File
		if (FSO.FileExists(sFile))
		{
			UTIL_XML_Load(sFile);
			var xFile = XML_Doc.getElementsByTagName("Alarms")[0];
			var Str = '';
			var i = 0;

			try
			{
				var xFile_Items = xFile.getElementsByTagName("Alarm");
				while (i < xFile_Items.length)
				{
					try
					{	
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-ID'>" + xFile_Items[i].getAttribute("ID") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Hour'>" + xFile_Items[i].getAttribute("Hour") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Minute'>" + xFile_Items[i].getAttribute("Minute") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Day'>" + xFile_Items[i].getAttribute("Day") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Month'>" + xFile_Items[i].getAttribute("Month") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Year'>" + xFile_Items[i].getAttribute("Year") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Recurring'>" + xFile_Items[i].getAttribute("Recurring") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Recurring_Type'>" + xFile_Items[i].getAttribute("Recurring_Type") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Event_ID'>" + xFile_Items[i].getAttribute("Event_ID") + "</div>";
						Str += "<div class='Hidden' id='DT-Alarm-" + i + "-Sound'>" + xFile_Items[i].getAttribute("Sound") + "</div>";
						i++;
					}
					catch(err){}
				}
			}
			catch(err){}
			$_HTML("Alarms-List", Str);
			$_HTML("Alarms-Count", i);
		}
		else
		{
			try
			{
				//>> Set Presets
				var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?>';
				Str += '<Alarms />';
				$_HTML("Alarms-Count", 0);
				UTIL_STOR_Save_File("Date-Time-Alarms.xml", Str);
			}
			catch(err){}
		}
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Save
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Save()
{
	try
	{
		//>> Get Count
		var Alarm_Count = parseInt($("Alarms-Count").innerHTML);
		if (Alarm_Count > 0)
		{
			var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?><Alarms>';
			var i = 0;

			while (i < Alarm_Count)
			{
				var ID = $("DT-Alarm-" + i + "-ID").innerHTML;
				var Hour = $("DT-Alarm-" + i + "-Hour").innerHTML;
				var Minute = $("DT-Alarm-" + i + "-Minute").innerHTML;
				var Day = $("DT-Alarm-" + i + "-Day").innerHTML;
				var Month = $("DT-Alarm-" + i + "-Month").innerHTML;
				var Year = $("DT-Alarm-" + i + "-Year").innerHTML;
				var Recurring = $("DT-Alarm-" + i + "-Recurring").innerHTML;
				var Recurring_Type = $("DT-Alarm-" + i + "-Recurring_Type").innerHTML;
				var Event_ID = $("DT-Alarm-" + i + "-Event_ID").innerHTML;
				var Sound = $("DT-Alarm-" + i + "-Sound").innerHTML;
				if (ID != '')
				{
					Str += '<Alarm ID="' + ID + '" Hour="' + Hour + '" Minute="' + Minute + '" Day="' + Day + '" Month="' + Month + '" Year="' + Year + '" ';
					Str += 'Recurring="' + Recurring + '" Recurring_Type="' + Recurring_Type + '" Event_ID="' + Event_ID + '" Sound="' + Sound + '" />';
				}
				i++;
			}
			Str += '</Alarms>';
		}
		else
			var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?><Alarms />';

		UTIL_STOR_Save_File("Date-Time-Alarms.xml", Str);
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Delete
//  PARAMS >> Code(String)
//*************************************************************
function GADGET_ALARMS_Delete(Code)
{
	try
	{
		var Alarm_Count = parseInt($("Alarms-Count").innerHTML);
		var i = 0;
		while (i < Alarm_Count)
		{
			if (Code == $("DT-Alarm-" + i + "-ID").innerHTML)
			{
				$_HTML("DT-Alarm-" + i + "-ID", '');
				if ($("DT-Alarm-" + i + "-Event_ID").innerHTML != '')
				{
					try
					{
						var Event_Count = parseInt($("Events-Count").innerHTML);
						var X = 0;
						while (X < Event_Count)
						{
							if ($("DT-Alarm-" + i + "-Event_ID").innerHTML == $("DT-Event-" + X + "-ID").innerHTML)
								$_HTML("DT-Event-" + X + "-Alarm", '');
							X++;
						}
					}
					catch(err){} 
				}
			}
			i++;
		}
		GADGET_ALARMS_Save();
		GADGET_ALARMS_Load();
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Check
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Check()
{
	try
	{
		//>> Get Time & Date
		var xDate = new Date();
		var xMinute = xDate.getMinutes(); 
		var xHour = xDate.getHours();
		var xDay = xDate.getDate();
		var xMonth = xDate.getMonth() + 1;
		var xYear = xDate.getYear();
		
		//>> Set Up Alarm Loop
		var Flag = '';
		var Alarm_Sound = '';
		var Delete = new Array();
		var i = 0;
		var X = 0;
		var Alarm_Count = parseInt($("Alarms-Count").innerHTML);
		while (i < Alarm_Count)
		{
			var ID = $("DT-Alarm-" + i + "-ID").innerHTML;
			var Hour = $("DT-Alarm-" + i + "-Hour").innerHTML;
			var Minute = $("DT-Alarm-" + i + "-Minute").innerHTML;
			var Day = $("DT-Alarm-" + i + "-Day").innerHTML;
			var Month = $("DT-Alarm-" + i + "-Month").innerHTML;
			var Year = $("DT-Alarm-" + i + "-Year").innerHTML;
			var Recurring = $("DT-Alarm-" + i + "-Recurring").innerHTML;
			var Recurring_Type = $("DT-Alarm-" + i + "-Recurring_Type").innerHTML;
			var Event_ID = $("DT-Alarm-" + i + "-Event_ID").innerHTML;
			var Sound = $("DT-Alarm-" + i + "-Sound").innerHTML;
			
			//>> Test Alarms
			if (Minute == xMinute)
			{
				if (Recurring == "Yes")
				{
					if (Recurring_Type == "Hourly")
					{
						Flag = "Yes";
						if (Sound == "On" && Alarm_Sound == '')
							Alarm_Sound = "On";
					}
					else if (Recurring_Type == "Daily" && Hour == xHour)
					{
						Flag = "Yes";
						if (Sound == "On" && Alarm_Sound == '')
							Alarm_Sound = "On";
					}
					else if (Recurring_Type == "Monthly" && Day == xDay && Hour == xHour)
					{
						Flag = "Yes";
						if (Sound == "On" && Alarm_Sound == '')
							Alarm_Sound = "On";
					}
					else if (Recurring_Type == "Yearly" && Month == xMonth && Day == xDay && Hour == xHour)
					{
						Flag = "Yes";
						if (Sound == "On" && Alarm_Sound == '')
							Alarm_Sound = "On";
					}
					else if (Recurring_Type == "Event")
					{
						try
						{
							var Event_Count = parseInt($("Events-Count").innerHTML);
							var yDate = xMonth + '/' + xDay + '/' + xYear;
							var Y = 0;
							while (Y < Event_Count)
							{
								var yID = $("DT-Event-" + Y + "-ID").innerHTML;
								var yRecurring = $("DT-Event-" + Y + "-Recurring").innerHTML;
								var yRec_Count = $("DT-Event-" + Y + "-Rec_Count").innerHTML;
								var yRec_Type = $("DT-Event-" + Y + "-Rec_Type").innerHTML;
								var yRanged = $("DT-Event-" + Y + "-Ranged").innerHTML;
								var yStart = $("DT-Event-" + Y + "-Start").innerHTML;
								var yEnd = $("DT-Event-" + Y + "-End").innerHTML;
								var yTime = $("DT-Event-" + Y + "-Time").innerHTML;
								if (GADGET_EVENTS_Test(yRecurring, yRec_Count, yRec_Type, yRanged, yStart, yEnd, yDate) == true && Event_ID == yID)
								{
									if (yTime == '')
										yTime = "12:00";
									var ySplit = yTime.split(":");
									var yHour = ySplit[0];
									var yMin = ySplit[1];
									if (yHour == xHour && yMin == xMinute)
										Flag = "Yes";
									
									if (Sound == "On" && Alarm_Sound == '')
										Alarm_Sound = "On";
								}
								Y++;
							}
						}
						catch(err){}
					}
				}
				else
				{
					if (Hour == xHour && Day == xDay && Month == xMonth && Year == xYear)
					{
						Flag = "Yes";
						if (Sound == "On" && Alarm_Sound == '')
							Alarm_Sound = "On";
						Delete[X] = ID;
						X++;
					}
				}
			}				
			i++;
		}
		
		//>> Sound Alarm
		if (Flag == "Yes")
		{
			UTIL_VAR_Write("xAlarm_Sound", Alarm_Sound);
			if (Alarm_Sound == "On")
			{
				var Alarm_Sound = UTIL_VAR_Read("Alarm_Sound", "Default");
				if (Alarm_Sound == "Default")
					Alarm_Sound = "Alarm.wav";

				$("Alarm").src = Alarm_Sound;
				$("Alarm").loop = "INFINITE";
			}

			$_Hide("DT-Clock-0");
			$_Show("Sec-Alarm");
			$_Class("Button-Alarm", "Button-Alarm-Active");
		}
		
		//>> Delete Once Only Alarms
		if (X > 0)
		{
			i = 0;
			while (i < X)
			{
				GADGET_ALARMS_Delete(Delete[i]);
				i++;
			}
		}
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Stop
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Stop()
{
	try
	{
		$_Show("DT-Clock-0");
		$_Hide("Sec-Alarm");
		$_Class("Button-Alarm", "Button-Alarm-Orig");
		$("Alarm").src = '';
		clearInterval(Timer_Snooze);
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Snooze
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Snooze()
{
	try
	{
		$_Show("DT-Clock-0");
		$_Hide("Sec-Alarm");
		$_Class("Button-Alarm", "Button-Alarm-Orig");
		$("Alarm").src = '';
		
		clearInterval(Timer_Snooze);
		Timer_Snooze = setInterval(GADGET_ALARMS_Snooze_Sound, UTIL_VAR_Read("Snooze_Time", 600000));
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> ALARMS: Snooze Sound
//  PARAMS >> None
//*************************************************************
function GADGET_ALARMS_Snooze_Sound()
{
	try
	{
		if (UTIL_VAR_Read("xAlarm_Sound", "On") == "On")
		{
			var Alarm_Sound = UTIL_VAR_Read("Alarm_Sound", "Default");
			if (Alarm_Sound == "Default")
				Alarm_Sound = "Alarm.wav";

			$("Alarm").src = Alarm_Sound;
			$("Alarm").loop = "INFINITE";
		}

		$_Hide("DT-Clock-0");
		$_Show("Sec-Alarm");
		$_Class("Button-Alarm", "Button-Alarm-Active");
		clearInterval(Timer_Snooze);
	}
	catch(err){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> EVENTS: Load
//  PARAMS >> None
//*************************************************************
function GADGET_EVENTS_Load()
{
	try
	{
		//>> Load Control XML File
		UTIL_XML_Load(STOR_File);
		var xFile = XML_Doc.getElementsByTagName("Storage")[0];

		//>> Parse Location
		var xFile_Location = xFile.getElementsByTagName("Location")[0];
		var Path = xFile_Location.getElementsByTagName("Path")[0].text;
		var File = xFile_Location.getElementsByTagName("Events")[0].text;

		//>> Verify Path
		var sPath = UTIL_STOR_Check_Path(Path);		
		var sFile = sPath + "\\" + File;

		//>> Test For File
		if (FSO.FileExists(sFile))
		{
			UTIL_XML_Load(sFile);
			var xFile = XML_Doc.getElementsByTagName("Events")[0];
			var Str = '';
			var i = 0;

			try
			{
				var xFile_Items = xFile.getElementsByTagName("Event");
				while (i < xFile_Items.length)
				{
					try
					{	
						try { Str += "<div id='DT-Event-" + i + "-ID' class='Hidden'>" + xFile_Items[i].getAttribute("ID") + "</div>"; }
						catch(err){ Str += "<div id='DT-Event-" + i + "-ID' class='Hidden'>" + GADGET_Generate_ID() + "</div>"; }
						
						Str += "<div id='DT-Event-" + i + "-Color' class='Hidden'>" + xFile_Items[i].getAttribute("Color") + "</div>";
						Str += "<div id='DT-Event-" + i + "-Ranged' class='Hidden'>" + xFile_Items[i].getAttribute("Ranged") + "</div>";
						Str += "<div id='DT-Event-" + i + "-Recurring' class='Hidden'>" + xFile_Items[i].getAttribute("Recurring") + "</div>";
						Str += "<div id='DT-Event-" + i + "-Rec_Count' class='Hidden'>" + xFile_Items[i].getAttribute("Rec_Count") + "</div>";
						Str += "<div id='DT-Event-" + i + "-Rec_Type' class='Hidden'>" + xFile_Items[i].getAttribute("Rec_Type") + "</div>";
						Str += "<div id='DT-Event-" + i + "-Start' class='Hidden'>" + xFile_Items[i].getAttribute("Start") + "</div>";
						Str += "<div id='DT-Event-" + i + "-End' class='Hidden'>" + xFile_Items[i].getAttribute("End") + "</div>";
						
						try { Str += "<div id='DT-Event-" + i + "-Time' class='Hidden'>" + xFile_Items[i].getAttribute("Time") + "</div>"; }
						catch(err){ Str += "<div id='DT-Event-" + i + "-Time' class='Hidden'>12:00</div>"; }
						
						try { Str += "<div id='DT-Event-" + i + "-Alarm' class='Hidden'>" + xFile_Items[i].getAttribute("Alarm") + "</div>"; }
						catch(err){ Str += "<div id='DT-Event-" + i + "-Alarm' class='Hidden'></div>"; }
						
						Str += "<div id='DT-Event-" + i + "-Title' class='Hidden'>" + xFile_Items[i].getElementsByTagName("Title")[0].text + "</div>";
						Str += "<div id='DT-Event-" + i + "-Notes' class='Hidden'>" + xFile_Items[i].getElementsByTagName("Notes")[0].text + "</div>";
						i++;
					}
					catch(err){}
				}				
				$_HTML("Events-List", Str);
				$_HTML("Events-Count", i);
			}
			catch(err){}
		}
		else
		{
			try
			{
				//>> Set Presets
				var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?>';
				Str += '<Events />';
				$_HTML("Events-Count", 0);
				UTIL_STOR_Save_File("Date-Time-Events.xml", Str);
			}
			catch(err){}
		}
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> EVENTS: Save
//  PARAMS >> None
//*************************************************************
function GADGET_EVENTS_Save()
{
	try
	{
		//>> Get Count
		var Event_Count = parseInt($("Events-Count").innerHTML);
		if (Event_Count > 0)
		{
			var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?><Events>';
			var i = 0;
   
			while (i < Event_Count)
			{
				var ID = $("DT-Event-" + i + "-ID").innerHTML;
   				var Color = $("DT-Event-" + i + "-Color").innerHTML;
				var Ranged = $("DT-Event-" + i + "-Ranged").innerHTML;
				var Recurring = $("DT-Event-" + i + "-Recurring").innerHTML;
				var Rec_Count = $("DT-Event-" + i + "-Rec_Count").innerHTML;
				var Rec_Type = $("DT-Event-" + i + "-Rec_Type").innerHTML;
				var Start = $("DT-Event-" + i + "-Start").innerHTML;
				var End = $("DT-Event-" + i + "-End").innerHTML;
				var Time = $("DT-Event-" + i + "-Time").innerHTML;
				var Alarm = $("DT-Event-" + i + "-Alarm").innerHTML;
				var Title = $("DT-Event-" + i + "-Title").innerHTML;
				var Notes = $("DT-Event-" + i + "-Notes").innerHTML;
				if (ID != '')
				{
					Str += '<Event ID="' + ID + '" Color="' + Color + '" Ranged="' + Ranged + '" Recurring="' + Recurring + '" ';
					Str += 'Rec_Count="' + Rec_Count + '" Rec_Type="' + Rec_Type + '" Start="' + Start + '" End="' + End + '" Time="' + Time + '" Alarm="' + Alarm + '">';
					Str += '<Title>' + Title + '</Title>';
					Str += '<Notes>' + Notes + '</Notes>';
					Str += '</Event>';
				}
				i++;
			}
			Str += '</Events>';
		}
		else
			var Str = '<?xml version="1.0" encoding="ISO-8859-1" ?><Events />';
		
		UTIL_STOR_Save_File("Date-Time-Events.xml", Str);
	}
	catch(err){}
}

//*************************************************************
//  GADGET >> EVENTS: Check
//  PARAMS >> None
//*************************************************************
function GADGET_EVENTS_Check()
{
	var i = 0;
	var xDate = new Date();
	var xMonth = parseFloat(xDate.getMonth() + 1);
	var xDay = parseFloat(xDate.getDate());
	var xYear = parseFloat(xDate.getYear());
	xDate = xMonth + '/' + xDay + '/' + xYear;
	
	var Event_Count = parseInt($("Events-Count").innerHTML);
	$_Hide("Button-Event");
	UTIL_VAR_Write("Event_Flag", "Off");
	var Event_Cleanup = UTIL_VAR_Read("Event_Cleanup", "On");

	if (UTIL_VAR_Read("Event_Ignore", '') != xDate && Event_Count > 0)
	{
		while (i < Event_Count)
		{
			var Recurring = $("DT-Event-" + i + "-Recurring").innerHTML;
			var Rec_Count = $("DT-Event-" + i + "-Rec_Count").innerHTML;
			var Rec_Type = $("DT-Event-" + i + "-Rec_Type").innerHTML;
			var Ranged = $("DT-Event-" + i + "-Ranged").innerHTML;
			var Start = $("DT-Event-" + i + "-Start").innerHTML;
			var End = $("DT-Event-" + i + "-End").innerHTML;				
			if (GADGET_EVENTS_Test(Recurring, Rec_Count, Rec_Type, Ranged, Start, End, xDate) == true)
			{
				UTIL_VAR_Write("Event_Flag", "On");
				$_Show("Button-Event");
				break;
			}
			if (Event_Cleanup == "On")
			{
				if (Recurring == "No")
				{				
					if (Ranged == "No")
					{
						sDate = Start.split("/");
						sMonth = sDate[0];
						sDay = sDate[1];
						sYear = sDate[2];
					
						if (sYear < xYear || sYear == xYear && sMonth < xMonth || sYear == xYear && sMonth == xMonth && sDay < xDay)
							GADGET_EVENT_Delete(i);
					}
					else
					{
						eDate = End.split("/");
						eMonth = eDate[0];
						eDay = eDate[1];
						eYear = eDate[2];
   
						if (eYear < xYear || eYear == xYear && eMonth < xMonth || eYear == xYear && eMonth == xMonth && eDay < xDay)
							GADGET_EVENT_Delete(i);	
					}
				}
			}
			
			i++;
		}
	}
}

//*************************************************************
//  GADGET >> EVENTS: Test Date Variables
//  PARAMS >> Recurring, Rec_Count, Rec_Type, Ranged, Start, End, xDate
//*************************************************************
function GADGET_EVENTS_Test(Recurring, Rec_Count, Rec_Type, Ranged, Start, End, xDate)
{
	var Test = false;
	var sDate = Date.parse(Start);
	if (Ranged == "Yes")
		var eDate = Date.parse(End);
	var tDate = Date.parse(xDate);
	Rec_Count = parseInt(Rec_Count);
	
	if (Recurring == "No" && Ranged == "No" && sDate == tDate)
		Test = true;
	else if (Recurring == "No" && Ranged == "Yes")
	{
		var oDiff = eDate - sDate;
		var tDiff = eDate - tDate;
		if (tDiff <= oDiff && tDiff >= 0)
			Test = true;	
	}
	else if (Recurring == "Yes" && Ranged == "No")
	{
		var sDateX = Start.split("/");
		var sDateX_Year = parseInt(sDateX[2]);
		var sDateX_Month = parseInt(sDateX[0]) - 1;
		var sDateX_Day = parseInt(sDateX[1]);
		var tDateX = xDate.split("/");
		var Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day).valueOf();
		var Test_Date = new Date(tDateX[2], parseInt(tDateX[0]) - 1, tDateX[1]).valueOf();
		
		while (Start_Date <= Test_Date)
		{
			if (Start_Date == Test_Date)
			{
				Test = true;
				break;
			}

			if (Rec_Type == "Days")
				sDateX_Day += Rec_Count;
			else if (Rec_Type == "Weeks")
				sDateX_Day += (Rec_Count * 7);
			else if (Rec_Type == "Months")
				sDateX_Month += Rec_Count;
			else if (Rec_Type == "Years")
				sDateX_Year += Rec_Count;				
			Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day).valueOf();
		}		
	}
	else if (Recurring == "Yes" && Ranged == "Yes")
	{
		var sDateX = Start.split("/");
		var sDateX_Year = parseInt(sDateX[2]);
		var sDateX_Month = parseInt(sDateX[0]) - 1;
		var sDateX_Day = parseInt(sDateX[1]);
		
		var eDateX = End.split("/");
		var eDateX_Year = parseInt(eDateX[2]);
		var eDateX_Month = parseInt(eDateX[0]) - 1;
		var eDateX_Day = parseInt(eDateX[1]);
		
		var tDateX = xDate.split("/");
		var Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day).valueOf();
		var End_Date = new Date(eDateX_Year, eDateX_Month, eDateX_Day).valueOf();
		var Test_Date = new Date(tDateX[2], parseInt(tDateX[0]) - 1, tDateX[1]).valueOf();

		while (Start_Date <= Test_Date)
		{
			var oDiff = End_Date - Start_Date;
			var tDiff = End_Date - Test_Date;
			if (tDiff <= oDiff && tDiff >= 0)
			{
				Test = true;
				break;
			}

			if (Rec_Type == "Days")
			{
				sDateX_Day += Rec_Count;
				eDateX_Day += Rec_Count;
			}
			else if (Rec_Type == "Weeks")
			{
				sDateX_Day += (Rec_Count * 7);
				eDateX_Day += (Rec_Count * 7);
			}
			else if (Rec_Type == "Months")
			{
				sDateX_Month += Rec_Count;
				eDateX_Month += Rec_Count;
			}
			else if (Rec_Type == "Years")
			{
				sDateX_Year += Rec_Count;
				eDateX_Year += Rec_Count;
			}			
			Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day).valueOf();
			End_Date = new Date(eDateX_Year, eDateX_Month, eDateX_Day).valueOf();
		}
	}
	return Test;
}

//*************************************************************
//  GADGET >> EVENTS: Test Date Variables For Same Month
//  PARAMS >> Recurring, Rec_Count, Rec_Type, Ranged, Start, End, xDate
//*************************************************************
function GADGET_EVENTS_Test_Month(Recurring, Rec_Count, Rec_Type, Ranged, Start, End, xDate)
{
	var Test = false;
	
	var tDate = Date.parse(xDate);
	var tDateX = xDate.split("/");
	var tDateX_Year = parseInt(tDateX[2]);
	var tDateX_Month = parseInt(tDateX[0]) - 1;
	var tDateX_Day = parseInt(tDateX[1]);
	
	var sDate = Date.parse(Start);
	var sDateX = Start.split("/");
	var sDateX_Year = parseInt(sDateX[2]);
	var sDateX_Month = parseInt(sDateX[0]) - 1;
	var sDateX_Day = parseInt(sDateX[1]);
	
	if (Ranged == "Yes")
	{
		var eDate = Date.parse(End);
		var eDateX = End.split("/");
		var eDateX_Year = parseInt(eDateX[2]);
		var eDateX_Month = parseInt(eDateX[0]) - 1;
		var eDateX_Day = parseInt(eDateX[1]);
	}
	Rec_Count = parseInt(Rec_Count);

	if (Recurring == "No" && Ranged == "No" && tDateX_Year == sDateX_Year && tDateX_Month == sDateX_Month)
		Test = true;
	else if (Recurring == "No" && Ranged == "Yes")
	{
		var Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);
		var End_Date = new Date(eDateX_Year, eDateX_Month, eDateX_Day).valueOf();
		
		while (Start_Date.valueOf() <= End_Date)
		{
			if (Start_Date.getMonth() == tDateX_Month && Start_Date.getYear() == tDateX_Year)
			{
				Test = true;
				break;
			}
			sDateX_Day += 1;
			Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);
		}	
	}
	else if (Recurring == "Yes" && Ranged == "No")
	{
		var Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);
		var Test_Date = new Date(tDateX_Year, tDateX_Month, tDateX_Day);
		
		while (Start_Date.getYear() <= Test_Date.getYear() && Start_Date.getMonth() <= Test_Date.getMonth())
		{
			if (Start_Date.getYear() <= Test_Date.getYear() && Start_Date.getMonth() == Test_Date.getMonth())
			{
				Test = true;
				break;
			}

			if (Rec_Type == "Days")
				sDateX_Day += Rec_Count;
			else if (Rec_Type == "Weeks")
				sDateX_Day += (Rec_Count * 7);
			else if (Rec_Type == "Months")
				sDateX_Month += Rec_Count;
			else if (Rec_Type == "Years")
				sDateX_Year += Rec_Count;
			Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);	
		}		
	}
	else if (Recurring == "Yes" && Ranged == "Yes")
	{
		var Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);
		var End_Date = new Date(eDateX_Year, eDateX_Month, eDateX_Day);
		var Test_Date = new Date(tDateX_Year, tDateX_Month, tDateX_Day);
		var sDateY_Day = sDateX_Day;

		while (Start_Date.getYear() <= Test_Date.getYear() && Start_Date.getMonth() <= Test_Date.getMonth())
		{
			while (Start_Date.valueOf() <= End_Date.valueOf())
			{
				if (Start_Date.getMonth() == tDateX_Month && Start_Date.getYear() <= tDateX_Year)
				{
					Test = true;
					break;
				}
				sDateY_Day += 1;
				Start_Date = new Date(sDateX_Year, sDateX_Month, sDateY_Day);
			}

			if (Rec_Type == "Days")
			{
				sDateX_Day += Rec_Count;
				eDateX_Day += Rec_Count;
			}
			else if (Rec_Type == "Weeks")
			{
				sDateX_Day += (Rec_Count * 7);
				eDateX_Day += (Rec_Count * 7);
			}
			else if (Rec_Type == "Months")
			{
				sDateX_Month += Rec_Count;
				eDateX_Month += Rec_Count;
			}
			else if (Rec_Type == "Years")
			{
				sDateX_Year += Rec_Count;
				eDateX_Year += Rec_Count;
			}			
			Start_Date = new Date(sDateX_Year, sDateX_Month, sDateX_Day);
			End_Date = new Date(eDateX_Year, eDateX_Month, eDateX_Day);
		}
	}
	return Test;
}

//*************************************************************
//  FLYOUT >> Delete Event
//  PARAMS >> X (Event ID)
//*************************************************************
function GADGET_EVENT_Delete(X)
{
	try
	{
		//>> Check For Corresponding Alarm
		if ($("DT-Event-" + X + "-Alarm").innerHTML == "Yes")
		{
			var i = 0;
			var ID = $("DT-Event-" + X + "-ID").innerHTML;
			var Alarm_Count = parseInt($("Alarms-Count").innerHTML);
			while (i < Alarm_Count)
			{
				if ($("DT-Alarm-" + i + "-Event_ID").innerHTML == ID)
				{
					GADGET_ALARMS_Delete($("DT-Alarm-" + i + "-ID").innerHTML);
					break;
				}
				i++;
			}
		}
   
		$_HTML("DT-Event-" + X + "-ID", '');
		GADGET_EVENTS_Save();
		GADGET_EVENTS_Load();
		GADGET_EVENTS_Check();
	}
	catch(err){}
}

//*************************************************************
//  FLYOUT >> Upgrade Events
//  PARAMS >> None
//*************************************************************
function GADGET_EVENTS_Upgrade()
{
	//>> Get Current Events File
	var sPath = System.Gadget.path;
	var sPos = System.Gadget.path.lastIndexOf("\\");
	var sFilename = sPath.substr(0,sPos) + "\\DTEvents.xml";
	if ($("Events-Count").innerHTML == '')
		$_HTML("Events-Count", "0");
	if (FSO.FileExists(sFilename))
	{
		UTIL_XML_Load(sFilename);
		var xFile = XML_Doc.getElementsByTagName("DTEvents")[0];
		var Str = '';
		var i = 0;

		try
		{
			var xFile_Items = xFile.getElementsByTagName("Event");
			while (i < xFile_Items.length)
			{
				var Ranged = xFile_Items[i].getElementsByTagName("EventRanged")[0].text;
				var Start = xFile_Items[i].getElementsByTagName("EventStart")[0].text;
				var End = xFile_Items[i].getElementsByTagName("EventEnd")[0].text;
				var Title = xFile_Items[i].getElementsByTagName("EventTitle")[0].text;
				var Notes = xFile_Items[i].getElementsByTagName("EventDescrip")[0].text;
			
				//>> Set Event Info In Gadget
				var Event_Count = $("Events-Count").innerHTML;
				$_HTML("Events-Count", parseInt(Event_Count) + 1);
				
				var ID_Div = System.Gadget.document.createElement('div');
				ID_Div.setAttribute("id", "DT-Event-" + Event_Count + "-ID");
				ID_Div.setAttribute("class", "Hidden");
				ID_Div.innerHTML = GADGET_Generate_ID();
				$("Events-List").appendChild(ID_Div);
   
				var Color_Div = System.Gadget.document.createElement('div');
				Color_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Color");
				Color_Div.setAttribute("class", "Hidden");
				Color_Div.innerHTML = "Gray";
				$("Events-List").appendChild(Color_Div);
   
				var Ranged_Div = System.Gadget.document.createElement('div');
				Ranged_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Ranged");
				Ranged_Div.setAttribute("class", "Hidden");
				Ranged_Div.innerHTML = Ranged;
				$("Events-List").appendChild(Ranged_Div);
   
				var Recurring_Div = System.Gadget.document.createElement('div');
				Recurring_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Recurring");
				Recurring_Div.setAttribute("class", "Hidden");
				Recurring_Div.innerHTML = "No";
				$("Events-List").appendChild(Recurring_Div);
   
				var Rec_Count_Div = System.Gadget.document.createElement('div');
				Rec_Count_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Rec_Count");
				Rec_Count_Div.setAttribute("class", "Hidden");
				Rec_Count_Div.innerHTML = "1";
				$("Events-List").appendChild(Rec_Count_Div);
   
				var Rec_Type_Div = System.Gadget.document.createElement('div');
				Rec_Type_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Rec_Type");
				Rec_Type_Div.setAttribute("class", "Hidden");
				Rec_Type_Div.innerHTML = "Months";
				$("Events-List").appendChild(Rec_Type_Div);
   
				var Start_Div = System.Gadget.document.createElement('div');
				Start_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Start");
				Start_Div.setAttribute("class", "Hidden");
				Start_Div.innerHTML = Start;
				$("Events-List").appendChild(Start_Div);
   
				var End_Div = System.Gadget.document.createElement('div');
				End_Div.setAttribute("id", "DT-Event-" + Event_Count + "-End");
				End_Div.setAttribute("class", "Hidden");
				End_Div.innerHTML = End;
				$("Events-List").appendChild(End_Div);
				
				var Time_Div = System.Gadget.document.createElement('div');
				Time_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Time");
				Time_Div.setAttribute("class", "Hidden");
				Time_Div.innerHTML = "12:00";
				$("Events-List").appendChild(Time_Div);
				
				var Alarm_Div = System.Gadget.document.createElement('div');
				Alarm_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Alarm");
				Alarm_Div.setAttribute("class", "Hidden");
				Alarm_Div.innerHTML = '';
				$("Events-List").appendChild(Alarm_Div);
   
				var Title_Div = System.Gadget.document.createElement('div');
				Title_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Title");
				Title_Div.setAttribute("class", "Hidden");
				Title_Div.innerHTML = Title;
				$("Events-List").appendChild(Title_Div);
   
				var Notes_Div = System.Gadget.document.createElement('div');
				Notes_Div.setAttribute("id", "DT-Event-" + Event_Count + "-Notes");
				Notes_Div.setAttribute("class", "Hidden");
				Notes_Div.innerHTML = Notes;
				$("Events-List").appendChild(Notes_Div);
   
				i++;
			}
			
			//>> Save Event Data
			GADGET_EVENTS_Save();
			GADGET_EVENTS_Load();
			
			FSO.DeleteFile(sFilename, true);
		}
		catch(err){}
	}
	UTIL_VAR_Write("Events_Upgraded", "Yes");
	UTIL_STOR_Save();
}